"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NominatecaneRawMapper = exports.NominatecaneMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const aw_antelope_1 = require("@alien-worlds/aw-antelope");
const entities_1 = require("../../domain/entities");
class NominatecaneMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('cand', {
            key: 'cand',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('requestedpay', {
            key: 'requestedpay',
            mapper: (value) => new aw_antelope_1.AssetMongoMapper().fromEntity(value),
        });
        this.mappingFromEntity.set('dacId', {
            key: 'dac_id',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { cand, requestedpay, dac_id, _id, ...rest } = mongoModel;
        return entities_1.Nominatecane.create(cand || '', requestedpay ? new aw_antelope_1.AssetMongoMapper().toEntity(requestedpay) : aw_antelope_1.Asset.getDefault(), dac_id || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.NominatecaneMongoMapper = NominatecaneMongoMapper;
class NominatecaneRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { cand, requestedpay, dac_id, ...rest } = rawModel;
        return entities_1.Nominatecane.create(cand || '', requestedpay ? new aw_antelope_1.AssetRawMapper().toEntity(requestedpay) : aw_antelope_1.Asset.getDefault(), dac_id || '', undefined, rest);
    }
}
exports.NominatecaneRawMapper = NominatecaneRawMapper;
