"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StprofileRawMapper = exports.StprofileMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const entities_1 = require("../../domain/entities");
class StprofileMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('cand', {
            key: 'cand',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('profile', {
            key: 'profile',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('dacId', {
            key: 'dac_id',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { cand, profile, dac_id, _id, ...rest } = mongoModel;
        return entities_1.Stprofile.create(cand || '', profile || '', dac_id || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.StprofileMongoMapper = StprofileMongoMapper;
class StprofileRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { cand, profile, dac_id, ...rest } = rawModel;
        return entities_1.Stprofile.create(cand || '', profile || '', dac_id || '', undefined, rest);
    }
}
exports.StprofileRawMapper = StprofileRawMapper;
