"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DaoWorldsContractServiceImpl = void 0;
const aw_antelope_1 = require("@alien-worlds/aw-antelope");
class DaoWorldsContractServiceImpl extends aw_antelope_1.AntelopeSmartContractServiceImpl {
    constructor(antelopeRpcSourceImpl, serviceUrl) {
        super(antelopeRpcSourceImpl, serviceUrl, 'dao.worlds');
    }
    async fetchCandidates(options) {
        const table_key = 'candidate_name';
        const tableRowOptions = {
            ...options,
            code: 'dao.worlds',
            table: 'candidates',
            table_key,
        };
        return options?.limit > 0
            ? await this.getMany(tableRowOptions)
            : await this.getAll(table_key, tableRowOptions);
    }
    async fetchCandidates2(options) {
        const table_key = 'candidate_name';
        const tableRowOptions = {
            ...options,
            code: 'dao.worlds',
            table: 'candidates2',
            table_key,
        };
        return options?.limit > 0
            ? await this.getMany(tableRowOptions)
            : await this.getAll(table_key, tableRowOptions);
    }
    async fetchCandperms(options) {
        const table_key = 'cand';
        const tableRowOptions = {
            ...options,
            code: 'dao.worlds',
            table: 'candperms',
            table_key,
        };
        return options?.limit > 0
            ? await this.getMany(tableRowOptions)
            : await this.getAll(table_key, tableRowOptions);
    }
    async fetchCustodians1(options) {
        const table_key = 'cust_name';
        const tableRowOptions = {
            ...options,
            code: 'dao.worlds',
            table: 'custodians1',
            table_key,
        };
        return options?.limit > 0
            ? await this.getMany(tableRowOptions)
            : await this.getAll(table_key, tableRowOptions);
    }
    async fetchDacglobals(options) {
        const table_key = '';
        const tableRowOptions = {
            ...options,
            code: 'dao.worlds',
            table: 'dacglobals',
            table_key,
        };
        return options?.limit > 0
            ? await this.getMany(tableRowOptions)
            : await this.getAll(table_key, tableRowOptions);
    }
    async fetchPendingpay(options) {
        const table_key = 'key';
        const tableRowOptions = {
            ...options,
            code: 'dao.worlds',
            table: 'pendingpay',
            table_key,
        };
        return options?.limit > 0
            ? await this.getMany(tableRowOptions)
            : await this.getAll(table_key, tableRowOptions);
    }
    async fetchProxies(options) {
        const table_key = 'proxy';
        const tableRowOptions = {
            ...options,
            code: 'dao.worlds',
            table: 'proxies',
            table_key,
        };
        return options?.limit > 0
            ? await this.getMany(tableRowOptions)
            : await this.getAll(table_key, tableRowOptions);
    }
    async fetchVotes(options) {
        const table_key = 'voter';
        const tableRowOptions = {
            ...options,
            code: 'dao.worlds',
            table: 'votes',
            table_key,
        };
        return options?.limit > 0
            ? await this.getMany(tableRowOptions)
            : await this.getAll(table_key, tableRowOptions);
    }
}
exports.DaoWorldsContractServiceImpl = DaoWorldsContractServiceImpl;
